DECLARE SUB yesno (answer%)
DECLARE SUB Pause ()
DECLARE SUB ViewQuoteFile (file() AS STRING, header() AS STRING, filenumb%, printer$)
DECLARE SUB ReadDoc (printer$)
DECLARE SUB NumberOfQuotes (filenumb%, file() AS STRING, Delim() AS STRING, header() AS STRING, NewLMCon%, NewLMNumb%)
DECLARE SUB AutoExec (direc$)
DECLARE SUB ViewAll (printer$)
DECLARE SUB textbox (Row%, Col%, Message$, Outline%, length%)
DECLARE SUB LocateIt (Row%, text$)
DECLARE SUB TwoColrs (Fgd%, Bkg%, Colr%)
DECLARE SUB ClearKey ()
DECLARE FUNCTION GetInput$ (Limit%, Line$)
DECLARE FUNCTION Startup$ ()
DECLARE SUB HideMouse ()
DECLARE SUB getmouse (k%, x%, y%)
DECLARE SUB EndIt ()
DECLARE SUB Sleeper ()
DECLARE SUB secfile (file2$)

REM $INCLUDE: 'c:\qb45\qb.bi'

'COPYRIGHT 1994 by Brian Deitte


DEFINT A-Z

DIM SHARED InregsX AS RegTypeX, OutregsX AS RegTypeX
DIM SHARED Inregs AS RegType, Outregs AS RegType
COMMON SHARED dumb$, Endy



CONST TRUE = -1
CONST FALSE = NOT TRUE


coma$ = COMMAND$
IF coma$ = "/?" OR coma$ = "?" OR coma$ = "-?" THEN
   PRINT
   PRINT "There are no command-line options."
   PRINT "Please read sayings.doc for"
   PRINT "more information on this file."
 END
END IF
IF coma$ = "/A" THEN Auto$ = "Just Do It"
IF LEFT$(coma$, 2) = "/A" AND LEN(coma$) > 3 THEN Auto$ = RIGHT$(coma$, LEN(coma$) - 2)
IF coma$ = "/D" THEN ReadD = TRUE

IF Auto$ <> "" THEN
  IF Auto$ = "Just Do It" THEN
    CALL AutoExec(direc$)
  ELSE
    CALL AutoExec(Auto$)
  END IF
  END
END IF


SCREEN 0
WIDTH 80, 25
RANDOMIZE TIMER

DIM file(1 TO 200) AS STRING, header(1 TO 200) AS STRING, QuoteN(1 TO 200) AS INTEGER
DIM DocLine(1 TO 22) AS STRING, Delim(1 TO 200) AS STRING
DIM SHARED DelimFirst(1 TO 200)

ON ERROR GOTO NoOpen
DeLoc$ = ENVIRON$("SAYINGS") + "\"
IF DeLoc$ = "\" THEN DeLoc$ = ""
OPEN DeLoc$ + "sayings.ini" FOR INPUT AS #1
ON ERROR GOTO 0

DO UNTIL EOF(1)

  LINE INPUT #1, IniLine$

  IF LTRIM$(IniLine$) = "" THEN GOTO Ender
  IF LEFT$(LTRIM$(IniLine$), 1) = ";" THEN GOTO Ender

  b% = INSTR(IniLine$, "=")          'find out where the = sign is

  
  TotalNum% = LEN(IniLine$)             'find total number of characters
  IniLineL$ = LEFT$(IniLine$, (b% - 1)) 'get the characters to the left of =
  LeftNum% = LEN(IniLineL$)             'find the total on left of = sign
  RightNum% = TotalNum% - LeftNum% - 1  'figure out the right side's sum
  a$ = MID$(IniLine$, b% + 1, RightNum%)'copy characters on right side of =

  IniLineL$ = LCASE$(RTRIM$(LTRIM$(IniLineL$)))
  a$ = LCASE$(RTRIM$(LTRIM$(a$)))

  Yes = FALSE
  IF LEFT$(a$, 1) = "y" THEN Yes = TRUE
 
  SELECT CASE IniLineL$
 

  CASE "file location"
    filenumb = filenumb + 1
    file(filenumb) = a$
    IF NoHeader = TRUE THEN header(filenumb) = ""
    IF NoDelim = TRUE THEN Delim(filenumb) = "NewL2"
      NoHeader = TRUE
      NoDelim = TRUE
    GOTO Ender

  CASE "header"
    IF NoHeader = TRUE THEN
      header(filenumb) = MID$(IniLine$, INSTR(IniLine$, "=") + 1, RightNum%)
      NoHeader = FALSE
    END IF
  GOTO Ender

  CASE "new quote deliminator"
    'what character to use to indicate a new quote
    IF NoDelim = TRUE THEN
      SELECT CASE LEFT$(a$, 10)
      CASE "blank line"
	Delim(filenumb) = "NewL2"
	IF LEN(a$) > 10 THEN
	  NewL2Numb = VAL(MID$(a$, 12, 1))
	  END IF
      CASE "return"
	Delim(filenumb) = "NewL"
      CASE "new line"
	Delim(filenumb) = "NewL"
      CASE "enter"
	Delim(filenumb) = "NewL"
      CASE "tab"
	Delim(filenumb) = STRING$(1, 15)
      END SELECT
      IF VAL(a$) <> 0 THEN
	Delim(filenumb) = "NewLM"
	NewLMNumb = VAL(a$)
	IF MID$(a$, LEN(NewLMNumb), 1) = "c" THEN NewLMCon = TRUE
      END IF
      IF Delim(filenumb) = "" THEN Delim(filenumb) = a$
      IF Delim(filenumb) = "" THEN Delim(filenumb) = "NewL2"
      NoDelim = FALSE
    END IF
    GOTO Ender
 
  CASE "deliminator is first on line"
    IF Yes = TRUE THEN DelimFirst(filenumb) = TRUE
    GOTO Ender
 
  CASE "printer"
    IF LEFT$(a$, 3) = "lpt" THEN
      IF VAL(MID$(a$, 4, 1)) = 1 OR VAL(MID$(a$, 4, 1)) = 2 THEN
	printer$ = a$
      END IF
    ELSE
      IF LEFT$(a$, 3) = "com" THEN
	IF VAL(MID$(a$, 4, 1)) > 0 AND VAL(MID$(a$, 4, 1)) < 5 THEN
	  printer$ = LEFT$(a$, 4)
	END IF
      END IF
    END IF

  END SELECT

Ender:
LOOP
CLOSE

pnt = 1
IF ReadD = TRUE THEN
  ReadDoc printer$
  COLOR 7, 0
  CLS
  END
END IF
Main:
COLOR 15, 9
CLS
COLOR 7, 1
LOCATE , , 0
CALL textbox(4, 28, SPACE$(19), 5, 8)
LOCATE 5, 32
PRINT "SAYINGS Utilities";
oldpnt = pnt
FOR pnt = 1 TO 7
  GOSUB Texty
NEXT pnt
pnt = oldpnt
CALL HideMouse
DO
  COLOR 1, 7
  GOSUB Texty
  LOCATE pnt + 6, 30
  COLOR 7, 1
  PRINT CHR$(254)
  CALL ClearKey
  CALL getmouse(newk, newx, newy)
  DO
    COLOR 7, 1
    DO
hi:
      oldk = newk: oldy = newy
      CALL getmouse(newk, newx, newy)
      dumb$ = INKEY$
    LOOP UNTIL dumb$ <> "" OR oldk <> newk OR oldy <> newy
    IF dumb$ = "" THEN       'mouse up
      IF newy < oldy THEN
	IF pnt <> 1 THEN
	  LOCATE pnt + 6, 30
	  PRINT " "
	  GOSUB Texty
	  pnt = pnt - (oldy - newy)
	  IF pnt < 1 THEN pnt = 1
	  IF pnt = 6 THEN pnt = 5
	  EXIT DO
	END IF
      ELSE
	IF newy > oldy THEN     'mouse down
	  IF pnt <> 7 THEN
	    LOCATE pnt + 6, 30
	    PRINT " "
	    GOSUB Texty
	    pnt = pnt + (newy - oldy)
	    IF pnt > 7 THEN pnt = 7
	    IF pnt = 6 THEN pnt = 7

	    EXIT DO
	  END IF
	ELSE
	    IF newk = 1 THEN GOTO pnter
	    IF newk = 3 THEN CALL EndIt
	END IF
      END IF
      GOTO hi
    ELSE
      IF ASC(RIGHT$(dumb$, 1)) = 72 THEN GOSUB up
      IF ASC(RIGHT$(dumb$, 1)) = 80 THEN GOSUB down
    END IF
    SELECT CASE dumb$
      CASE CHR$(27)
	CALL EndIt
      CASE "1"
	CLS
	SHELL DeLoc$ + "say"
	CALL Pause
	GOTO Main
      CASE "2"
	CALL ReadDoc(printer$)
	GOTO Main
      CASE "3"
	CALL ViewQuoteFile(file(), header(), filenumb, printer$)
	GOTO Main
      CASE "4"
	CALL NumberOfQuotes(filenumb, file(), Delim(), header(), NewLMCon, NewLMNumb)
	GOTO Main
      CASE "5"
	CALL AutoExec(direc$)
	GOTO Main
      CASE "6"
	CALL EndIt
      CASE CHR$(13)
pnter:
	SELECT CASE pnt
	  CASE 1
	    CLS
	    SHELL DeLoc$ + "say"
	    CALL Pause
	    GOTO Main
	  CASE 2
	    CALL ReadDoc(printer$)
	    GOTO Main
	  CASE 3
	    CALL ViewQuoteFile(file(), header(), filenumb, printer$)
	    GOTO Main
	  CASE 4
	    CALL NumberOfQuotes(filenumb, file(), Delim(), header(), NewLMCon, NewLMNumb)
	    GOTO Main
	  CASE 5
	    CALL AutoExec(direc$)
	    GOTO Main
	  CASE 7
	    CALL EndIt
	END SELECT
      END SELECT
    IF new = TRUE THEN EXIT DO
  LOOP
  new = FALSE
LOOP

up:
GOSUB Texty
LOCATE pnt + 6, 30
PRINT " "
new = TRUE
IF pnt = 1 THEN
  pnt = 7
  RETURN
END IF
IF pnt > 1 AND pnt < 8 THEN
  IF pnt = 7 THEN pnt = pnt - 1
  pnt = pnt - 1
END IF
RETURN

down:
GOSUB Texty
LOCATE pnt + 6, 30
PRINT " "
new = TRUE
IF pnt = 7 THEN
  pnt = 1
  RETURN
END IF
IF pnt > 0 AND pnt < 7 THEN
  IF pnt = 5 THEN pnt = pnt + 1
  pnt = pnt + 1
  END IF
RETURN

Texty:
SELECT CASE pnt
  CASE 1
    LOCATE 7, 31
    PRINT "1. See a quote"
  CASE 2
    LOCATE 8, 31
    PRINT "2. Read Sayings.doc"
  CASE 3
    LOCATE 9, 31
    PRINT "3. View a quote file"
  CASE 4
    LOCATE 10, 31
    PRINT "4. Count quotes"
  CASE 5
    LOCATE 11, 31
    PRINT "5. Configure system"
    LOCATE 12, 31
    PRINT "   for sayings"
  CASE 7
    LOCATE 13, 31
    PRINT "6. Exit"
END SELECT
RETURN


NoOpen:
PRINT "The program could not find the file sayings.ini."
PRINT "and/or sayutil.ini"
PRINT "Please switch to the directory with the file in it,"
PRINT "or add the line "
PRINT "SAYINGS=_directory_"
PRINT "to your autoexec.bat, where _directory is where "
PRINT "sayings.ini and sayutil.ini are stored."
END



Nop:
RESUME NEXT

ErrHandler:
BEEP
SELECT CASE ERR
  CASE 53
    Msg$ = "Cannot find file"
  CASE 52, 64
    Msg$ = "Bad file name"
  CASE 61
    Msg$ = "Disk full"
  CASE 70
    Msg$ = "Permission denied."
  CASE 71
    Msg$ = "Disk not ready."
  CASE 75, 76
    Msg$ = "Path/File access error."
  CASE ELSE
    Msg$ = "The error" + STR$(ERR) + " occurred."
  END SELECT

PRINT Msg$ + CHR$(13) + "Press any key to continue..."
WHILE INKEY$ = "": WEND
GOTO Main

SUB AutoExec (direc$)
COLOR 15, 1
CLS
PRINT "The following procedure will add lines to your autoexec.bat for"
PRINT "helping the program run.  (This will include a environment string"
PRINT "and line to run the program.) These lines ARE NOT neccesary but"
PRINT "will allow you to run the program from a different directory."
PRINT "May I continue? ";
CALL yesno(answer)
COLOR 15, 1
IF answer = FALSE THEN EXIT SUB
PRINT ""
PRINT "Would you like to add a statement that will allow"
PRINT "sayings to be accessed from anywhere? ";
CALL yesno(answer)
COLOR 15, 1
IF answer = TRUE THEN path = TRUE
IF direc$ <> "" THEN
  path$ = direc$
ELSE
WhereIsStored:
  CLS
  LOCATE 5, 1
  PRINT "What is the name of the directory where your sayings program"
  PRINT "is stored?"
  PRINT "[Type quit to quit]"
  LOCATE , , 1
  dumb$ = GetInput(50, "c:\sayings")
  dumb$ = LCASE$(LTRIM$(RTRIM$(dumb$)))
  IF dumb$ = "quit" THEN
    LOCATE , , 0
    EXIT SUB
  END IF
  path$ = LTRIM$(RTRIM$(dumb$))
END IF
IF LEN(path$) >= 3 THEN
  IF MID$(path$, 2, 1) <> ":" OR MID$(path$, 3, 1) <> "\" THEN GOTO WhereIsStored
ELSE
  GOTO WhereIsStored
END IF
Namey:
start$ = Startup$
start$ = start$ + "\autoexec.bat"
LOCATE , , 1
PRINT
PRINT
PRINT "What is the name of your start-up batch file?"
PRINT "[Type quit to quit]"
dumb$ = GetInput$(30, start$)
IF LCASE$(LTRIM$(RTRIM$(dumb$))) = "quit" THEN
  LOCATE , , 0
  EXIT SUB
END IF
IF LTRIM$(dumb$) = "" THEN
  file$ = start$
ELSE
  file$ = LTRIM$(RTRIM$(dumb$))
END IF
ON ERROR GOTO ErrHandler
OPEN file$ FOR APPEND AS #1
IF LOF(1) = 0 THEN
  CLOSE
  KILL file$
  GOTO Namey
END IF
LOCATE , , 0
SEEK 1, LOF(1)
PRINT #1, ""
PRINT #1, "SET SAYINGS="; path$
PRINT #1, path$; "\say"
IF path = TRUE THEN PRINT #1, "PATH %PATH%;"; path$
CLS
LOCATE 5, 1
PRINT "Complete."
PRINT "The following lines were added to the end of "; file$; ":"
PRINT
PRINT "SET SAYINGS="; path$
PRINT path$; "\say"
IF path = TRUE THEN PRINT "PATH %PATH%;"; path$
PRINT ""
PRINT "Press any key to continue..."
WHILE INKEY$ = "": WEND
CLOSE
LOCATE , , 0
EXIT SUB
ON ERROR GOTO 0
END SUB

SUB ClearKey
  DO
    dumb$ = ""
    dumb$ = INKEY$
    IF dumb$ = "" THEN EXIT DO
  LOOP
END SUB

SUB Ender (file$, file2$)
CLOSE
INPUT "Would you like to keep these changes?", a$
IF LEFT$(LTRIM$(LCASE$(a$)), 1) = "y" THEN
  INPUT "Would you like to keep the old file?", a$
    IF LEFT$(LTRIM$(LCASE$(a$)), 1) = "n" THEN
      KILL file$
      NAME file2$ AS file$
      PRINT
      PRINT "The file /"; file$; "/ was deleted and"
      PRINT "the file /"; file$; "/ was renamed as"
      PRINT "/"; file$; "/"
      PRINT
      PRINT "Press any key to continue..."
      SLEEP
      dumb$ = INKEY$
    ELSE
      NAME file$ AS "old.txt"
      NAME file2$ AS file$
      PRINT
      PRINT "The file /"; file$; "/ was renamed as old.txt"
      PRINT "and the file /"; file2$; "/ was renamed as the"
      PRINT "first file"
      PRINT
      PRINT "Press any key to continue..."
      SLEEP
      dumb$ = INKEY$
    END IF
ELSE
  KILL file2$
END IF
END SUB

SUB EndIt
COLOR 7, 0
CLS
PRINT
PRINT "Thanks for using SayUtil by Brian Deitte."
PRINT "    (We are all worms, but I do believe"
PRINT "     I am a glowworm. -Winston Churchill)"
PRINT
PRINT "This program is freeware."
PRINT "    (Always try to be a little kinder"
PRINT "     than is neccessary. -James M. Barrie)"
PRINT
PRINT "If you like this program, please contribute."
PRINT "    (Money is flat and meant to"
PRINT "     be piled up. -Scottish proverb)"
PRINT
PRINT "If you see anything wrong, please contact me"
PRINT "at the address in the docs."
PRINT "    (Only your real friends will tell you when your"
PRINT "     face is dirty. -Sicilian proverb)"
PRINT
PRINT "Thank you!"
PRINT "    (Determine that the thing can and shall be done,"
PRINT "     and then we shall find the way. -Abraham Lincoln)"
END
END SUB

FUNCTION GetInput$ (Limit, Line$) STATIC

count = LEN(Line$)
PRINT Line$;
DO
DoAgain:
	IF count = Limit THEN Lim = TRUE
	DO
		Char$ = INKEY$
	LOOP UNTIL LEN(Char$) > 0
	IF Char$ = CHR$(27) THEN
	  GetInput$ = "quit"
	  EXIT FUNCTION
	END IF
	IF Char$ = CHR$(13) THEN EXIT DO
	IF Char$ = CHR$(8) THEN
		IF LEN(Line$) > 0 THEN
			Line$ = LEFT$(Line$, LEN(Line$) - 1)
			PRINT CHR$(29) + " " + CHR$(29);
			Char$ = ""
			count = count - 1
		END IF
		Lim = FALSE
		GOTO DoAgain
	END IF
	IF Lim = TRUE THEN GOTO DoAgain
	IF ASC(Char$) >= 32 AND ASC(Char$) <= 122 THEN
	  count = count + 1
	  Line$ = Line$ + Char$
	  PRINT Char$;
	ELSE
	  GOTO DoAgain
	END IF
LOOP

GetInput$ = Line$
END FUNCTION

DEFSNG A-Z
SUB getmouse (k%, x%, y%)
Inregs.ax% = 3
CALL INTERRUPT(&H33, Inregs, Outregs)
x% = Outregs.cx% / 8 + 1
y% = Outregs.dx% / 8 + 1
k% = Outregs.bx%
END SUB

DEFINT A-Z
SUB HideMouse
Inregs.ax% = 2
CALL INTERRUPT(&H33, Inregs, Outregs)
END SUB

SUB LocateIt (Row%, text$)
     LOCATE Row%, 41 - LEN(text$) / 2
     PRINT text$;
END SUB

SUB NumberOfQuotes (filenumb, file() AS STRING, Delim() AS STRING, header() AS STRING, NewLMCon, NewLMNumb)
CLS
DO UNTIL count = filenumb
count = count + 1
b% = 1
OPEN file(count) FOR INPUT AS #1
  SELECT CASE Delim(count)
  CASE "NewL2"
    DO UNTIL EOF(1)
      LINE INPUT #1, a$
      IF RTRIM$(LTRIM$(a$)) = "" THEN b% = b% + 1
    LOOP

  CASE "NewL"
    b% = 0
    DO UNTIL EOF(1)
      LINE INPUT #1, a$
      b% = b% + 1
    LOOP

  CASE "NewLM"
    StillBlank = TRUE
    counter = 0
    IF NewLMCon = TRUE THEN
      DO UNTIL EOF(1)
	LINE INPUT #1, a$
	IF LTRIM$(RTRIM$(a$)) = "" THEN
	  IF StillBlank = TRUE THEN
	    counter = counter + 1
	    IF counter = NewLMNumb THEN
	      counter = 0
	      b% = b% + 1
	    END IF
	  ELSE
	    counter = counter + 1
	    StillBlank = TRUE
	  END IF
	ELSE
	  StillBlank = FALSE
	  counter = 0
	END IF
      LOOP
    ELSE
      DO UNTIL EOF(1)
	LINE INPUT #1, a$
	IF RTRIM$(LTRIM$(a$)) = "" THEN
	  counter = counter + 1
	  IF counter = NewLMNumb THEN
	    counter = 0
	    b% = b% + 1
	  END IF
	END IF
      LOOP
   END IF

  CASE ELSE
    LenDelim = LEN(Delim(count))
    IF DelimFirst(count) = TRUE THEN
      DO UNTIL EOF(1)
	LINE INPUT #1, a$
	IF a$ = Delim(count) THEN b% = b% + 1
      LOOP
    ELSE
      DO UNTIL EOF(1)
	a$ = INPUT$(LEN(Delim(count)), #1)
	IF LenDelim > 1 THEN SEEK #1, LOC(1) - LenDelim + 1
	IF a$ = Delim(count) THEN b% = b% + 1
	LOOP
    END IF
END SELECT
  tot = tot + b%
  IF header(count) <> "" THEN
    PRINT header(count) + "-"; b%
  ELSE
    PRINT file(count) + "-"; b%
  END IF
  CLOSE
  IF count = 21 AND count <> filenumb THEN
  PRINT ""
  PRINT "Press any key to continue..."
  CALL Sleeper
  END IF
LOOP
PRINT ""
PRINT "TOTAL- "; tot
PRINT "Press any key to continue..."
CALL Sleeper
EXIT SUB
END SUB

SUB Pause
    WHILE INKEY$ <> "": WEND
    WHILE INKEY$ = "": WEND
END SUB

SUB ReadDoc (printer$)
IF ENVIRON$("sayings") <> "" THEN
  OPEN ENVIRON$("SAYINGS") + "\" + "sayings.doc" FOR INPUT AS #1
ELSE
  OPEN "sayings.doc" FOR INPUT AS #1
END IF
CALL ViewAll(printer$)
END SUB

SUB secfile (file2$)
INPUT ; "What should I name the new file?", file2$
IF file2$ = "" OR INSTR(a$, ".") = 0 OR LEN(a$) > 12 THEN file2$ = "newfile.txt"
OPEN file2$ FOR APPEND AS #2
END SUB

SUB ShowMouse
Inregs.ax% = 1
CALL INTERRUPT(&H33, Inregs, Outregs)
END SUB

SUB ShowTextFiles (file() AS STRING, filenumb, file$, file2$, count)
CLS
DIM choices$(0 TO 7)
'choices$(0) = "Please choose a file"
'choices$(7) = "Exit"
LOCATE 3, 1
PRINT "Please choose a file"
bottom = 1: curb = 1
GOSUB new
DO
  IF curb > 6 THEN
    IF bottom + 5 < filenumb THEN
      bottom = bottom + 1
      GOSUB new
    END IF
  ELSE
    IF curb < 1 THEN
      IF bottom > 1 THEN
	bottom = bottom - 1
	GOSUB new
      END IF
    ELSE
      IF up = TRUE THEN
	LOCATE curb + 5, 3
      ELSE
	LOCATE curb + 3, 3
      END IF
      PRINT " "
      LOCATE curb + 4, 3
      PRINT CHR$(254)
    END IF
  END IF
  IF curb < 1 THEN curb = 1
  IF curb > 6 THEN curb = 6
  up = FALSE
  DO
    DO
      dumb$ = INKEY$
    LOOP WHILE dumb$ = ""
    IF ASC(dumb$) = 27 THEN EXIT SUB
    IF ASC(RIGHT$(dumb$, 1)) = 72 THEN
      up = TRUE
      curb = curb - 1
      EXIT DO
    END IF
    IF ASC(RIGHT$(dumb$, 1)) = 80 THEN
      curb = curb + 1
      EXIT DO
    END IF
    IF dumb$ = CHR$(13) THEN
      IF file(bottom + curb - 1) <> "" THEN
	OPEN file(bottom + curb - 1) FOR INPUT AS #1
	CALL secfile(file2$)
	file$ = file(bottom + curb - 1)
	count = bottom + curb - 1
	EXIT SUB
      END IF
    END IF
  LOOP
LOOP
new:
countit = 0
FOR z = bottom TO bottom + 5
  countit = countit + 1
  LOCATE countit + 4, 4
  PRINT SPACE$(40)
  LOCATE countit + 4, 4
  PRINT file(z)
  'choices$(countit) = file(z)
NEXT z
'CALL menusub(choices$(), 5, 5, 1, 7, 1)
RETURN
END SUB

SUB Sleeper
DO
  dumb$ = ""
  dumb$ = INKEY$
LOOP UNTIL dumb$ = ""
DO
  dumb$ = INKEY$
  CALL getmouse(k, x, y)
LOOP UNTIL dumb$ <> "" OR k <> 0
END SUB

DEFSNG A-Z
FUNCTION Startup$
  'finds the startup disk
  InregsX.ax = &H3305
  CALL INTERRUPTX(&H21, InregsX, OutregsX)
  Startup$ = CHR$(OutregsX.dx + 64) + ":"
END FUNCTION

DEFINT A-Z
SUB textbox (Row%, Col%, Message$, Outline%, length%)

    'Will put a message into a three line box -or-
    'draw a box without a message using Message$=SPACE$(x)
    'where "x" is the width of the box and Length%= number of lines > 3
    'All boxes are centered.
    'Now to make them non centered....

    Message$ = LEFT$(Message$, 60)
    BoxWidth% = LEN(Message$) + 4
    SELECT CASE Outline%
	CASE 0
	    J = 8 * 5 + 1
	CASE 1
	    J = 1
	CASE 2
	    J = 8 + 1
	CASE 3
	    J = 8 * 2 + 1
	CASE 4
	    J = 8 * 3 + 1
	CASE 5
	    J = 8 * 4 + 1
	CASE ELSE
	    J = 8 * 5 + 1
    END SELECT
  
	'if you use a lot of boxes put this in the main module as:
	'DIM SHARED Box$(1 to 8 * 6)
	REDIM box$(1 TO 8 * 6)

'single line box
    box$(1) = ""
    box$(2) = ""
    box$(3) = ""
    box$(4) = ""
    box$(5) = ""
    box$(6) = ""
    box$(7) = ""
    box$(8) = ""

'double top box
    box$(9) = ""
    box$(10) = ""
    box$(11) = ""
    box$(12) = ""
    box$(13) = ""
    box$(14) = ""
    box$(15) = ""
    box$(16) = ""

'double side box
    box$(17) = ""
    box$(18) = ""
    box$(19) = ""
    box$(20) = ""
    box$(21) = ""
    box$(22) = ""
    box$(23) = ""
    box$(24) = ""

'double box
    box$(25) = ""
    box$(26) = ""
    box$(27) = ""
    box$(28) = ""
    box$(29) = ""
    box$(30) = ""
    box$(31) = ""
    box$(32) = ""

'bold and thick box
    box$(33) = ""
    box$(34) = ""
    box$(35) = ""
    box$(36) = ""
    box$(37) = ""
    box$(38) = ""
    box$(39) = ""
    box$(40) = ""

'no box
    box$(41) = " "
    box$(42) = " "
    box$(43) = " "
    box$(44) = " "
    box$(45) = " "
    box$(46) = " "
    box$(47) = " "
    box$(48) = " "
  
    IF Col% = 0 THEN
      
	    Boxtext$ = box$(J) + STRING$(BoxWidth%, box$(J + 1)) + box$(J + 2)
	    CALL LocateIt(Row%, Boxtext$)
	    Row2% = CSRLIN: col2% = POS(0)
	    Colr% = SCREEN(Row2%, col2% - 1, 1)
	    CALL TwoColrs(Fgd%, Bkg%, Colr%)
	   
	    FOR I = 1 TO length% + 1
	    Boxtext$ = box$(J + 3) + "  " + Message$ + "  " + box$(J + 4)
	    CALL LocateIt(Row% + I, Boxtext$)
	    COLOR 8, 0
	    FOR k = 1 TO 2
		 PRINT CHR$(SCREEN(CSRLIN, POS(0)));
	    NEXT
	    COLOR Fgd%, Bkg%
	    NEXT I
  
	    Boxtext$ = box$(J + 5) + STRING$(BoxWidth%, box$(J + 6)) + box$(J + 7)
	    CALL LocateIt(Row% + I, Boxtext$)
	    COLOR 8, 0
	    FOR k = 1 TO 2
		 PRINT CHR$(SCREEN(CSRLIN, POS(0)));
	    NEXT
	    'COLOR Fgd%, Bkg%
	   
	    COLOR 8, 0
	    LOCATE Row% + I + 1, (41 - LEN(Boxtext$) / 2) + 2
	    FOR k = 1 TO BoxWidth% + 2
		PRINT CHR$(SCREEN(CSRLIN, POS(0)));
	    NEXT
	    COLOR Fgd%, Bkg%
  
    ELSE

	    Boxtext$ = box$(J) + STRING$(BoxWidth%, box$(J + 1)) + box$(J + 2)
	    LOCATE Row%, Col%
	    PRINT Boxtext$;
	    Row2% = CSRLIN: col2% = POS(0)
	    Colr% = SCREEN(Row2%, col2% - 1, 1)
	    CALL TwoColrs(Fgd%, Bkg%, Colr%)

	    FOR I = 1 TO length% + 1
	    Boxtext$ = box$(J + 3) + "  " + Message$ + "  " + box$(J + 4)
	    LOCATE Row% + I, Col%
	    PRINT Boxtext$;
	    COLOR 8, 0
	    FOR k = 1 TO 2
		 PRINT CHR$(SCREEN(CSRLIN, POS(0)));
	    NEXT
	    COLOR Fgd%, Bkg%
	    NEXT I

	    Boxtext$ = box$(J + 5) + STRING$(BoxWidth%, box$(J + 6)) + box$(J + 7)
	    LOCATE Row% + I, Col%
	    PRINT Boxtext$;
	    COLOR 8, 0
	    FOR k = 1 TO 2
		 PRINT CHR$(SCREEN(CSRLIN, POS(0)));
	    NEXT
	    'COLOR Fgd%, Bkg%
	    'COLOR 8, 0
	    LOCATE Row% + I + 1, Col% + 2
	    FOR k = 1 TO BoxWidth% + 2
		PRINT CHR$(SCREEN(CSRLIN, POS(0)));
	    NEXT
	    COLOR Fgd%, Bkg%

    END IF
END SUB

SUB TwoColrs (Fgd%, Bkg%, Colr%)
 
    Fgd% = (Colr% AND 128) \ 8 + (Colr% AND 15)
    Bkg% = (Colr% AND 112) \ 16

END SUB

SUB ViewAll (printer$)
DIM page(1 TO 200) AS STRING
COLOR 7, 0
DO
  IF EOF(1) THEN EXIT DO
  bigcount = bigcount + 1
  LINE INPUT #1, liney$
  page(bigcount) = liney$
  FOR J = 1 TO 19
    IF EOF(1) THEN EXIT DO
    LINE INPUT #1, liney$
    page(bigcount) = page(bigcount) + CHR$(13) + liney$
  NEXT J
LOOP
NPages = bigcount
bigcount = 1
GOSUB show

DO
DO
  a$ = INKEY$
  CALL getmouse(k, x, y)
  IF k = 1 THEN
    bigcount = bigcount + 1
    GOSUB show
  END IF
  IF k = 2 THEN
    bigcount = bigcount - 1
    GOSUB show
  END IF
LOOP UNTIL a$ <> ""
SELECT CASE LCASE$(a$)
  CASE CHR$(13)
    bigcount = bigcount + 1
    GOSUB show
  CASE CHR$(32)
    bigcount = bigcount - 1
    GOSUB show
  CASE CHR$(27)
    CLOSE
    EXIT SUB
  CASE "a"
    IF printer$ <> "" THEN
      ON ERROR GOTO Nop
      OPEN printer$ + ":" FOR OUTPUT AS #2
      FOR x = 1 TO NPages
	PRINT #2, page(x)
      NEXT x
      ON ERROR GOTO 0
      CLOSE 2
    END IF
  CASE "p"
    IF printer$ <> "" THEN
      ON ERROR GOTO Nop
      OPEN printer$ + ":" FOR OUTPUT AS #2
      PRINT #2, page(bigcount)
      ON ERROR GOTO 0
      CLOSE 2
    END IF
  END SELECT
LOOP

show:
IF bigcount < 1 THEN
  bigcount = 1
  RETURN
END IF
IF bigcount > NPages THEN
  bigcount = NPages
  RETURN
END IF
CLS
LOCATE 1, 1
COLOR 7, 1
PRINT "   Enter- Next Page    Space Bar - Previous Page    P- Print this page   ";
PRINT bigcount
LOCATE 2, 1
PRINT "                Esc- Quit                A- Print whole document                "
PRINT ""
COLOR 7, 0
PRINT page(bigcount)
RETURN
END SUB

SUB ViewQuoteFile (file() AS STRING, header() AS STRING, filenumb, printer$)
DIM page(1 TO 80) AS STRING
CLS
FOR x = 1 TO filenumb
  z = z + 1
  IF header(x) <> "" THEN
    LOCATE z + 4, 25
    PRINT STR$(x) + ". " + header(x)
  ELSE
    LOCATE z + 4, 25
    PRINT STR$(x) + ". " + file(x)
  END IF
  IF z > 15 THEN
    z = 0
    PRINT "Press any key to continue..."
    SLEEP
    dumb$ = INKEY$
    CLS
  END IF
NEXT x
DO
LOCATE 6 + z, 26
PRINT SPACE$(35)
LOCATE 6 + z, 26
INPUT "View which file? ", dumb$
dumb$ = LCASE$(dumb$)
IF dumb$ = "quit" OR dumb$ = "exit" OR dumb$ = "q" THEN EXIT SUB
choice = VAL(dumb$)
IF choice >= 1 AND choice <= filenumb THEN EXIT DO
LOOP
OPEN file(choice) FOR INPUT AS #1
CALL ViewAll(printer$)
END SUB

SUB yesno (answer)
answer = -1
col1 = 15
col2 = 4
col3 = 9
vert = CSRLIN
horz = POS(0)
WHILE INKEY$ <> "": WEND
DO
  LOCATE vert, horz
  IF answer = -1 THEN
    COLOR col1, col2: PRINT "Yes";
    COLOR col1, col3: PRINT " No"
  ELSE
    COLOR col1, col3: PRINT "Yes ";
    COLOR col1, col2: PRINT "No"
  END IF
  IF endnow = -1 THEN
    COLOR col2, col3
    EXIT SUB
  END IF
  a$ = INKEY$
  IF LEN(a$) <> 0 THEN
    SELECT CASE ASC(RIGHT$(a$, 1))
      CASE 75  'left
	IF answer = 0 THEN answer = -1
      CASE 77  'right
	IF answer = -1 THEN answer = 0
      CASE 121 OR 89 'y
	answer = -1
	endnow = -1
      CASE 110 OR 78 'n
	answer = 0
	endnow = -1
      CASE 13 'enter
	endnow = -1
  END SELECT
  END IF
LOOP

END SUB

